Index: CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/dialogs/liststyle.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/dialogs/liststyle.js	(revision 5427)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/dialogs/liststyle.js	(revision 5427)
@@ -0,0 +1,189 @@
+﻿/*
+ * Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+ * For licensing, see LICENSE.html or http://ckeditor.com/license
+ */
+ 
+(function()
+{
+	function getListElement( editor, listTag )
+	{
+		var range;
+		try { range  = editor.getSelection().getRanges()[ 0 ]; }
+		catch( e ) { return null; }
+				
+		range.shrink( CKEDITOR.SHRINK_TEXT );
+		return range.getCommonAncestor().getAscendant( listTag, true );
+	}
+	
+	var mapListStyle = {
+		'a' : 'lower-alpha',
+		'A' : 'upper-alpha',
+		'i' : 'lower-roman',
+		'I' : 'upper-roman',
+		'1' : 'decimal',
+		'disc' : 'disc',
+		'circle': 'circle',
+		'square' : 'square'
+	};
+	
+	function listStyle( editor, startupPage )
+	{
+		if ( startupPage == 'bulletedListStyle' )
+		{
+			return {
+				title : editor.lang.list.bulletedTitle,
+				minWidth : 300,
+				minHeight : 50,
+				contents :
+				[
+					{
+						elements :
+						[
+							{
+								type : 'select',
+								label : editor.lang.list.type,
+								id : 'type',
+								style : 'width: 150px; margin: auto;',
+								items :
+								[
+									[ editor.lang.list.notset, '' ],
+									[ editor.lang.list.circle, 'circle' ],
+									[ editor.lang.list.disc,  'disc' ],
+									[ editor.lang.list.square, 'square' ]
+								],
+								setup : function( element )
+								{
+									var value = element.getStyle( 'list-style-type' )
+												|| mapListStyle[ element.getAttribute( 'type' ) ]
+												|| element.getAttribute( 'type' )
+												|| '';
+
+									this.setValue( value );
+								},
+								commit : function( element )
+								{
+									var value = this.getValue();
+									if ( value != '' )
+										element.setStyle( 'list-style-type', value );
+									else 
+										element.removeStyle( 'list-style-type' );
+								}
+							}
+						]
+					}
+				],
+				onShow: function() 
+				{
+					var editor = this.getParentEditor(),
+						element = getListElement( editor, 'ul' );
+					
+					element && this.setupContent( element );
+				},
+				onOk: function()
+				{
+					var editor = this.getParentEditor(),
+						element = getListElement( editor, 'ul' );
+					
+					element && this.commitContent( element );
+				}
+			}
+		}
+		else if ( startupPage == 'numberedListStyle'  )
+		{
+			return {
+				title : editor.lang.list.numberedTitle,
+				minWidth : 300,
+				minHeight : 50,
+				contents :
+				[
+					{
+						elements :
+						[
+							{
+								type : 'hbox',
+								widths : [ '25%', '75%' ],
+								children :
+								[
+									{
+										label : editor.lang.list.start,
+										type : 'text',
+										id : 'start',
+										setup : function( element )
+										{
+											var value = element.getAttribute( 'start' ) || 1;
+											value && this.setValue( value );
+										},
+										commit : function( element )
+										{
+											element.setAttribute( 'start', this.getValue() );
+										}
+									},
+									{
+										type : 'select',
+										label : editor.lang.list.type,
+										id : 'type',
+										style : 'width: 100%;',
+										items :
+										[
+											[ editor.lang.list.notset, '' ],
+											[ editor.lang.list.armenian, 'armenian' ],
+											[ editor.lang.list.georgian, 'georgian' ],
+											[ editor.lang.list.lowerRoman, 'lower-roman' ],
+											[ editor.lang.list.upperRoman, 'upper-roman' ],
+											[ editor.lang.list.lowerAlpha, 'lower-alpha' ],
+											[ editor.lang.list.upperAlpha, 'upper-alpha' ],
+											[ editor.lang.list.lowerGreek, 'lower-greek' ],
+											[ editor.lang.list.decimal, 'decimal' ],
+											[ editor.lang.list.decimalLeadingZero, 'decimal-leading-zero' ],
+										],
+										setup : function( element )
+										{
+											var value = element.getStyle( 'list-style-type' )
+												|| mapListStyle[ element.getAttribute( 'type' ) ]
+												|| element.getAttribute( 'type' )
+												|| '';
+
+											this.setValue( value );
+										},
+										commit : function( element )
+										{
+											var value = this.getValue();
+											if ( value != '' ) 
+												element.setStyle( 'list-style-type', value );
+											else 
+												element.removeStyle( 'list-style-type' );
+										}
+									}
+								]
+							}
+						]
+					}
+				],
+				onShow: function() 
+				{
+					var editor = this.getParentEditor(),
+						element = getListElement( editor, 'ol' );
+
+					element && this.setupContent( element );
+				},
+				onOk: function()
+				{
+					var editor = this.getParentEditor(),
+						element = getListElement( editor, 'ol' );
+					
+					element && this.commitContent( element );
+				}
+			}
+		}
+	};
+	
+	CKEDITOR.dialog.add( 'numberedListStyle', function( editor )
+		{
+			return listStyle( editor, 'numberedListStyle' );
+		});
+
+	CKEDITOR.dialog.add( 'bulletedListStyle', function( editor )
+		{
+			return listStyle( editor, 'bulletedListStyle' );
+		});
+})();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/plugin.js	(revision 5427)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/liststyle/plugin.js	(revision 5427)
@@ -0,0 +1,61 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+(function()
+{
+	CKEDITOR.plugins.liststyle =
+	{
+		init : function( editor )
+		{
+
+			editor.addCommand( 'numberedListStyle', new CKEDITOR.dialogCommand( 'numberedListStyle' ) );
+			CKEDITOR.dialog.add( 'numberedListStyle', this.path + 'dialogs/liststyle.js' );
+			editor.addCommand( 'bulletedListStyle', new CKEDITOR.dialogCommand( 'bulletedListStyle' ) );
+			CKEDITOR.dialog.add( 'bulletedListStyle', this.path + 'dialogs/liststyle.js' );
+
+			//Register map group;
+			editor.addMenuGroup("list", 108);
+			// If the "menu" plugin is loaded, register the menu items.
+			if ( editor.addMenuItems )
+			{
+				editor.addMenuItems(
+					{
+						numberedlist :
+						{
+							label : editor.lang.list.numberedTitle,
+							group : 'list',
+							command: 'numberedListStyle'
+						},
+						bulletedlist :
+						{
+							label : editor.lang.list.bulletedTitle,
+							group : 'list',
+							command: 'bulletedListStyle'
+						}
+					});
+			}
+		
+			// If the "contextmenu" plugin is loaded, register the listeners.
+			if ( editor.contextMenu )
+			{
+				editor.contextMenu.addListener( function( element, selection )
+					{
+						if ( !element )
+							return null;
+						
+						if ( element.getAscendant( 'ol') ) {
+							return { numberedlist: CKEDITOR.TRISTATE_OFF }
+						}
+						if ( element.getAscendant( 'ul' ) ) {
+							return { bulletedlist: CKEDITOR.TRISTATE_OFF }
+						}
+					} );
+			}
+		}
+
+	};
+	
+	CKEDITOR.plugins.add( 'liststyle', CKEDITOR.plugins.liststyle );
+})();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js	(revision 5405)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js	(revision 5427)
@@ -65,5 +65,5 @@
  *     [
  *         'smiley', 'sad', 'wink', 'laugh', 'frown', 'cheeky', 'blush', 'surprise',
- *         'indecision', 'angry', 'angle', 'cool', 'devil', 'crying', 'enlightened', 'no',
+ *         'indecision', 'angry', 'angel', 'cool', 'devil', 'crying', 'enlightened', 'no',
  *         'yes', 'heart', 'broken heart', 'kiss', 'mail'
  *     ];
@@ -80,5 +80,5 @@
 	[
 		'smiley', 'sad', 'wink', 'laugh', 'frown', 'cheeky', 'blush', 'surprise',
-		'indecision', 'angry', 'angle', 'cool', 'devil', 'crying', 'enlightened', 'no',
+		'indecision', 'angry', 'angel', 'cool', 'devil', 'crying', 'enlightened', 'no',
 		'yes', 'heart', 'broken heart', 'kiss', 'mail'
 	];
Index: CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5405)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5427)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -1391,4 +1391,5 @@
  * possible to set the URL from which loading the styles file.<br>
  * Previously this setting was available as config.stylesCombo_stylesSet<br>
+ * @name CKEDITOR.config.stylesSet
  * @type String|Array
  * @default 'default'
Index: CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js	(revision 5405)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js	(revision 5427)
@@ -87,5 +87,5 @@
 	}
 
-	function getFocusedCell( cellsToDelete ) {
+	function getFocusElementAfterDelCells( cellsToDelete ) {
 		var i = 0,
 			last = cellsToDelete.length - 1,
@@ -248,4 +248,42 @@
 		}
 	}
+	
+	function getFocusElementAfterDelCols( cells ) 
+	{
+		var cellIndexList = [],
+			table = cells[ 0 ] && cells[ 0 ].getAscendant( 'table' ),
+			i, length,
+			targetIndex, targetCell;
+		
+		// get the cellIndex list of delete cells
+		for ( i = 0, length = cells.length; i < length; i++ )
+			cellIndexList.push( cells[i].$.cellIndex );
+
+		// get the focusable column index
+		cellIndexList.sort();
+		for ( i = 1, length = cellIndexList.length; i < length; i++ )
+		{
+			if ( cellIndexList[ i ] - cellIndexList[ i - 1 ] > 1 )
+			{
+				targetIndex = cellIndexList[ i - 1 ] + 1;
+				break;
+			}
+		}
+		
+		if ( !targetIndex )
+			targetIndex = cellIndexList[ 0 ] > 0 ? ( cellIndexList[ 0 ] - 1 ) 
+							: ( cellIndexList[ cellIndexList.length - 1 ] + 1 );
+
+		// scan row by row to get the target cell
+		var trs = table.$.getElementsByTagName( 'tr' );
+		for ( i = 0, length = trs.length; i < length ; i++ )
+		{
+			targetCell = trs[ i ].getElementsByTagName( 'td' )[ targetIndex ];
+			if ( targetCell )
+				break;
+		}
+
+		return targetCell ?  new CKEDITOR.dom.element( targetCell ) :  table.getPrevious();
+	}
 
 	function deleteColumns( selectionOrCell )
@@ -253,10 +291,14 @@
 		if ( selectionOrCell instanceof CKEDITOR.dom.selection )
 		{
-			var colsToDelete = getSelectedCells( selectionOrCell );
-			for ( var i = colsToDelete.length ; i >= 0 ; i-- )
+			var colsToDelete = getSelectedCells( selectionOrCell ),
+				elementToFocus = getFocusElementAfterDelCols( colsToDelete );
+
+			for ( var i = colsToDelete.length - 1 ; i >= 0 ; i-- )
 			{
 				if ( colsToDelete[ i ] )
 					deleteColumns( colsToDelete[ i ] );
 			}
+
+			return elementToFocus;
 		}
 		else if ( selectionOrCell instanceof CKEDITOR.dom.element )
@@ -264,4 +306,6 @@
 			// Get the cell's table.
 			var table = selectionOrCell.getAscendant( 'table' );
+			if ( !table )
+				return;
 
 			// Get the cell index.
@@ -316,5 +360,5 @@
 			var cellsToDelete = getSelectedCells( selectionOrCell );
 			var table = cellsToDelete[ 0 ] && cellsToDelete[ 0 ].getAscendant( 'table' );
-			var cellToFocus   = getFocusedCell( cellsToDelete );
+			var cellToFocus   = getFocusElementAfterDelCells( cellsToDelete );
 
 			for ( var i = cellsToDelete.length - 1 ; i >= 0 ; i-- )
@@ -768,5 +812,6 @@
 					{
 						var selection = editor.getSelection();
-						deleteColumns( selection );
+						var element = deleteColumns( selection );
+						element &&  placeCursorInCell( element, true );
 					}
 				} );
Index: CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5405)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5427)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -679,5 +679,6 @@
 									data =
 										config.docType +
-										'<html dir="' + config.contentsLangDirection + '">' +
+										'<html dir="' + config.contentsLangDirection + '"' +
+											' lang="' + ( config.contentsLanguage || editor.langCode ) + '">' +
 										'<title>' + frameLabel + '</title>' +
 										'<head>' +
